//
// Generated by SwagGen
// https://github.com/yonaskolb/SwagGen
//

import Foundation
import JSONUtilities

public class ErrorObject: JSONDecodable, JSONEncodable, PrettyPrintable {

    /** CloudPass error code */
    public var errorCode: String

    /** CloudPass error description */
    public var message: String

    /** This is completed if the IDP returns an error */
    public var externalCode: String?

    /** This is completed if the IDP returns an error */
    public var externalMessage: String?

    public init(errorCode: String, message: String, externalCode: String? = nil, externalMessage: String? = nil) {
        self.errorCode = errorCode
        self.message = message
        self.externalCode = externalCode
        self.externalMessage = externalMessage
    }

    public required init(jsonDictionary: JSONDictionary) throws {
        errorCode = try jsonDictionary.json(atKeyPath: "errorCode")
        message = try jsonDictionary.json(atKeyPath: "message")
        externalCode = jsonDictionary.json(atKeyPath: "externalCode")
        externalMessage = jsonDictionary.json(atKeyPath: "externalMessage")
    }

    public func encode() -> JSONDictionary {
        var dictionary: JSONDictionary = [:]
        dictionary["errorCode"] = errorCode
        dictionary["message"] = message
        if let externalCode = externalCode {
            dictionary["externalCode"] = externalCode
        }
        if let externalMessage = externalMessage {
            dictionary["externalMessage"] = externalMessage
        }
        return dictionary
    }

    /// pretty prints all properties including nested models
    public var prettyPrinted: String {
        return "\(Swift.type(of: self)):\n\(encode().recursivePrint(indentIndex: 1))"
    }
}
